define(["globalize","itemHelper","itemShortcuts","inputManager","connectionManager","playbackManager","imageLoader","layoutManager","browser","dom","loading","focusManager","serverNotifications","events","cardBuilder","virtual-scroller"],function(globalize,itemHelper,itemShortcuts,inputManager,connectionManager,playbackManager,imageLoader,layoutManager,browser,dom,loading,focusManager,serverNotifications,events,cardBuilder){"use strict";var MultiSelect,touchTarget;function onClick(e){e.target;var multiSelect=this.multiSelect;multiSelect&&!1===multiSelect.onContainerClick.call(this,e)||itemShortcuts.onClick.call(this,e)}function onContextMenu(e){var target=e.target,card=itemShortcuts.getItemElementFromChildNode(target,!0);if(card)return this.classList.contains("multi-select-active")||inputManager.trigger("menu",{sourceElement:card}),e.preventDefault(),e.stopPropagation(),!1}function onUserDataChanged(e,apiClient,userData){cardBuilder.onUserDataChanged(userData,this);var eventsToMonitor=getEventsToMonitor(this);(eventsToMonitor.includes("markfavorite")||eventsToMonitor.includes("markplayed"))&&this.notifyRefreshNeeded()}function getEventsToMonitor(itemsContainer){var monitor=itemsContainer.getAttribute("data-monitor");return monitor?monitor.split(","):[]}function onTimerCreated(e,apiClient,data){var programId,newTimerId;getEventsToMonitor(this).includes("timers")?this.notifyRefreshNeeded():(programId=data.ProgramId,newTimerId=data.Id,cardBuilder.onTimerCreated(programId,newTimerId,this))}function onSeriesTimerCreated(e,apiClient,data){getEventsToMonitor(this).includes("seriestimers")&&this.notifyRefreshNeeded()}function onTimerCancelled(e,apiClient,data){var id;getEventsToMonitor(this).includes("timers")?this.notifyRefreshNeeded():(id=data.Id,cardBuilder.onTimerCancelled(id,this))}function onSeriesTimerCancelled(e,apiClient,data){var id;getEventsToMonitor(this).includes("seriestimers")?this.notifyRefreshNeeded():(id=data.Id,cardBuilder.onSeriesTimerCancelled(id,this))}function onLibraryChanged(e,apiClient,data){var eventsToMonitor=getEventsToMonitor(this);if(!eventsToMonitor.includes("seriestimers")&&!eventsToMonitor.includes("timers")){var itemsAdded=data.ItemsAdded||[],itemsRemoved=data.ItemsRemoved||[];if(itemsAdded.length||itemsRemoved.length){var parentId=this.getAttribute("data-parentid");if(parentId){var foldersAddedTo=data.FoldersAddedTo||[],foldersRemovedFrom=data.FoldersRemovedFrom||[],collectionFolders=data.CollectionFolders||[];if(!foldersAddedTo.includes(parentId)&&!foldersRemovedFrom.includes(parentId)&&!collectionFolders.includes(parentId))return}this.notifyRefreshNeeded()}}}function onPlaybackStopped(e,stopInfo){var state=stopInfo.state,eventsToMonitor=getEventsToMonitor(this);if(state.NowPlayingItem&&"Video"===state.NowPlayingItem.MediaType){if(eventsToMonitor.includes("videoplayback"))return void this.notifyRefreshNeeded(!0)}else if(state.NowPlayingItem&&"Audio"===state.NowPlayingItem.MediaType&&eventsToMonitor.includes("audioplayback"))return void this.notifyRefreshNeeded(!0)}function addNotificationEvent(instance,name,handler,owner){var localHandler=handler.bind(instance);owner=owner||serverNotifications,events.on(owner,name,localHandler),instance["event_"+name]=localHandler}function removeNotificationEvent(instance,name,owner){var handler=instance["event_"+name];handler&&(owner=owner||serverNotifications,events.off(owner,name,handler),instance["event_"+name]=null)}function onInit(){this.hasInit||(this.hasInit=!0,this.classList.add("itemsContainer"))}function getTouches(e){return e.changedTouches||e.targetTouches||e.touches}function clearTouchStartTimeout(elem){elem.touchStartTimeout&&(clearTimeout(elem.touchStartTimeout),elem.touchStartTimeout=null,elem.touchStartTimeoutTime=null)}function clearTouchTarget(container){touchTarget&&(touchTarget=null,dom.removeEventListener(container,"touchmove",onTouchMove,{passive:!0}))}function onTouchStart(e){var element,card,touch=getTouches(e)[0];clearTouchTarget(this),this.touchStartX=0,this.touchStartY=0,touch&&(this.touchStartX=touch.clientX,this.touchStartY=touch.clientY,!(element=touch.target)||(card=element.closest(".card,.listItem"))&&(clearTouchStartTimeout(this),dom.addEventListener(this,"touchmove",onTouchMove,{passive:!0}),touchTarget=card,this.touchStartTimeout=setTimeout(onTouchStartTimerFired,550),this.touchStartTimeoutTime=Date.now()))}function onTouchMove(e){var touch,touchEndX,touchEndY,deltaX,deltaY;touchTarget&&(deltaY=(touch=getTouches(e)[0])?(touchEndX=touch.clientX||0,touchEndY=touch.clientY||0,deltaX=Math.abs(touchEndX-(this.touchStartX||0)),Math.abs(touchEndY-(this.touchStartY||0))):deltaX=100,(5<=deltaX||5<=deltaY)&&(clearTouchStartTimeout(this),clearTouchTarget(this)))}function onTouchEnd(e){var time;!getTouches(e)[0]||(time=this.touchStartTimeoutTime)&&500<=(time=Date.now()-time)&&e.preventDefault(),clearTouchStartTimeout(this),clearTouchTarget(this)}var emptyFn=function(){};function onTouchStartTimerFired(){var container,cardContentButton,card=touchTarget;card&&(container=card.closest(".itemsContainer"),(cardContentButton=card.querySelector(".cardContent-button")||card.querySelector("button")||card)&&focusManager.focus(cardContentButton),onContextMenu.call(container,{target:card,preventDefault:emptyFn,stopPropagation:emptyFn}))}function onDroppedOntoFullTarget(itemsContainer,draggedElement,dropTarget,item){var apiClient,droppedItemType=dropTarget.getAttribute("data-type"),droppedItemId=dropTarget.getAttribute("data-id"),droppedItemServerId=dropTarget.getAttribute("data-serverid");droppedItemId&&droppedItemServerId&&(apiClient=connectionManager.getApiClient(droppedItemServerId),"Playlist"!==droppedItemType&&"BoxSet"!==droppedItemType||function(apiClient,list,ids){loading.show();var apiName="BoxSet"===list.Type?"Collections":"Playlists",url=apiClient.getUrl(apiName+"/"+list.Id+"/Items",{Ids:ids,userId:apiClient.getCurrentUserId()});apiClient.ajax({type:"POST",url:url}).then(function(){loading.hide()})}(apiClient,{Id:droppedItemId,ServerId:droppedItemServerId,Type:droppedItemType},[item.Id]))}function onDroppedForReordering(e,itemsContainer,draggedElement,dropTarget){var directionUp,rect=dropTarget.getBoundingClientRect(),maxYForTop=rect.y+rect.height/2;e.clientY<=maxYForTop&&(directionUp=!0),function(itemsContainer,draggedElement,dropTarget,directionUp){var currentIndex=Array.prototype.indexOf.call(itemsContainer.children,draggedElement);itemsContainer.insertBefore(draggedElement,directionUp?dropTarget:dropTarget.nextSibling);var itemId,playlistId,serverId,apiClient,newIndex=Array.prototype.indexOf.call(itemsContainer.children,draggedElement);newIndex!==currentIndex&&(itemId=draggedElement.getAttribute("data-playlistitemid"),(playlistId=draggedElement.getAttribute("data-playlistid"))?(serverId=draggedElement.getAttribute("data-serverid"),apiClient=connectionManager.getApiClient(serverId),loading.show(),apiClient.ajax({url:apiClient.getUrl("Playlists/"+playlistId+"/Items/"+itemId+"/Move/"+newIndex),type:"POST"}).then(function(){loading.hide()},function(){loading.hide(),itemsContainer.refreshItems()})):draggedElement.dispatchEvent(new CustomEvent("itemdrop",{detail:{newIndex:newIndex,playlistItemId:itemId},bubbles:!0,cancelable:!1})))}(itemsContainer,draggedElement,dropTarget,directionUp)}function abortRequests(instance){var currentAbortController=instance.currentAbortController;currentAbortController&&(currentAbortController.abort(),instance.currentAbortController=null)}function onGetItemsFailed(){}function clearRefreshInterval(itemsContainer,isPausing){itemsContainer.refreshInterval&&(clearInterval(itemsContainer.refreshInterval),itemsContainer.refreshInterval=null,isPausing||(itemsContainer.refreshIntervalEndTime=null))}function resetRefreshInterval(itemsContainer,intervalMs){clearRefreshInterval(itemsContainer),(intervalMs=intervalMs||parseInt(itemsContainer.getAttribute("data-refreshinterval")||"0"))&&(itemsContainer.refreshInterval=setInterval(itemsContainer.notifyRefreshNeeded.bind(itemsContainer),intervalMs),itemsContainer.refreshIntervalEndTime=Date.now()+intervalMs)}function getVirtualChunkSize(elem,listOptions){var size=elem.virtualChunkSize;if(size)return size;var layout=listOptions?listOptions.virtualScrollLayout:elem.getAttribute("data-virtualscrolllayout");return layout?layout.includes("horizontal")?16:50:null}function onDataFetched(result){var sectionSeeAllButton,items=result.Items||result,parentContainer=this.parentContainer;parentContainer&&(items.length?((sectionSeeAllButton=parentContainer.querySelector(".sectionSeeAllButton"))&&(8<=items.length||"true"===this.getAttribute("data-alwaysshowseeall")?sectionSeeAllButton.classList.remove("hide"):sectionSeeAllButton.classList.add("hide")),parentContainer.classList.remove("hide")):parentContainer.classList.add("hide"));var focusId,hasActiveElement,focusIndexElement,focusIndex,activeElement=document.activeElement;this.contains(activeElement)&&(hasActiveElement=!0,focusId=activeElement.getAttribute("data-id"),focusIndexElement=itemShortcuts.getItemElementFromChildNode(activeElement,!0),focusIndex=focusIndexElement?focusIndexElement.getAttribute("data-index"):null);var virtualScroller,listItemOptions,itemParts,delay=0,listOptions=this.getListOptions?this.getListOptions(items):null,minItemsForVirtualRendering=this.onUpdateElement?0:25;return(items.length>=minItemsForVirtualRendering||items.length<(result.TotalRecordCount||0))&&this.hasAttribute("data-virtualscrolllayout")?(this.classList.add("virtualItemsContainer"),listOptions&&(listOptions.options.lazy=2,listOptions.renderer.setListOptions(items,listOptions.options)),(virtualScroller=this.virtualScroller)&&listOptions.enableScrollReuse&&virtualScroller.templateInnerHTML===listOptions.options.templateInnerHTML||(listItemOptions=(this.currentListOptions=listOptions).options,this.innerHTML='<div is="virtual-scroller" class="flex-grow virtualScroller" layout="'+listOptions.virtualScrollLayout+'"></div>',(virtualScroller=this.querySelector(".virtualScroller")).virtualChunkSize=getVirtualChunkSize(this,listOptions),virtualScroller.templateInnerHTML=listItemOptions.templateInnerHTML,virtualScroller.templateHTML="<"+listItemOptions.tagName+' class="virtualScrollItem '+listItemOptions.className+'">'+listItemOptions.templateInnerHTML+"</"+listItemOptions.tagName+">",virtualScroller.getItems=this.fetchData.bind(this),(this.virtualScroller=virtualScroller).updateElement=function(child,item,index){for(var chkCardSelect,listOptions=this.currentListOptions,listItemOptions=listOptions.options,renderer=listOptions.renderer,itemParts=this.itemParts[index]||(this.itemParts[index]=renderer.getItemParts(item,index,listItemOptions)),attributes=itemParts.attributes,i=0,length=attributes.length;i<length;i++){var att=attributes[i];child.setAttribute(att.name,att.value)}child.innerHTML=itemParts.html,MultiSelect&&item.Id&&MultiSelect.isSelected(item)&&((chkCardSelect=child.querySelector(".chkCardSelect"))&&(chkCardSelect.checked=!0,child.querySelector(".cardBox").classList.add("item-multiselected")));var onUpdateElement=this.onUpdateElement;this.onUpdateElement&&onUpdateElement(child,item,index)}.bind(this),virtualScroller.onRecycleElement=this.onRecycleElement,virtualScroller.onElementCreated=function(elem){addDragEventsToDropTarget(elem)}.bind(this)),this.items=null,(itemParts=[]).length=result.TotalRecordCount||items.length,this.itemParts=itemParts,delay=virtualScroller.setItemSource?(virtualScroller.setItemSource(items,result.TotalRecordCount),50):(dom.addEventListener(virtualScroller,"upgraded",function(e){var items=this.Items||this;e.currentTarget.setItemSource(items,this.TotalRecordCount)}.bind(result),{once:!0}),100)):(this.classList.remove("virtualItemsContainer"),this.itemParts=null,this.currentListOptions=null,this.innerHTML=listOptions?listOptions.renderer.getItemsHtml(items,listOptions.options):this.getItemsHtml(items),this.virtualScroller=null,this.items=items,imageLoader.lazyChildren(this),function(itemsContainer){for(var items=itemsContainer.querySelectorAll(".drop-target,*[draggable]"),i=0,length=items.length;i<length;i++){addDragEventsToDropTarget(items[i])}}(this)),(delay?function(delay){return new Promise(function(resolve,reject){setTimeout(resolve,delay)})}(delay):Promise.resolve()).then(function(){hasActiveElement&&function(itemsContainer,focusId,focusIndex){var newElement;if(focusId&&(newElement=itemsContainer.querySelector('[data-id="'+focusId+'"]')))try{return focusManager.focus(newElement)}catch(err){}if(null!=focusIndex)return itemsContainer.scrollToIndex(parseInt(focusIndex),!0);layoutManager.tv&&focusManager.autoFocus(itemsContainer)}(this,focusId,focusIndex),resetRefreshInterval(this),this.afterRefresh&&this.afterRefresh(result)}.bind(this))}function onItemDragStart(e){var draggableElement=e.target;draggableElement.classList.add("dragging"),e.dataTransfer.effectAllowed="copy",window.CurrentDragInfo={element:draggableElement,item:itemShortcuts.getItemFromChildNode(draggableElement)},setTimeout(function(){draggableElement.classList.remove("dragging")},100)}function onItemDragEnd(e){e.preventDefault(),window.CurrentDragInfo=null}function onItemDragEnter(e){if(!this.classList.contains("full-drop-target"))return onItemDragOver.call(this,e);var listType,data=window.CurrentDragInfo,item=data?data.item:null;!item||("Playlist"===(listType=this.getAttribute("data-type"))&&itemHelper.supportsAddingToPlaylist(item)||"BoxSet"===listType&&itemHelper.supportsAddingToCollection(item))&&(e.preventDefault(),this.classList.add("dragging-over"),this.dragCounter=(this.dragCounter||0)+1)}function onItemDragOver(e){var data=window.CurrentDragInfo,draggingElement=data?data.element:null;if(this.classList.contains("full-drop-target")){var listType,item=data?data.item:null;!item||("Playlist"===(listType=this.getAttribute("data-type"))&&itemHelper.supportsAddingToPlaylist(item)||"BoxSet"===listType&&itemHelper.supportsAddingToCollection(item))&&(e.preventDefault(),e.dataTransfer.dropEffect="copy")}else if(this.classList.contains("ordered-drop-target")&&draggingElement.classList.contains("ordered-drop-target")){e.preventDefault(),e.dataTransfer.dropEffect="copy";var elem=e.target;if(!(elem=elem.closest(".drop-target")))return;var classList=elem.classList,rect=elem.getBoundingClientRect(),maxYForTop=rect.y+rect.height/2;e.clientY<=maxYForTop?(classList.remove("dragging-over-bottom"),classList.add("dragging-over","dragging-over-top")):(classList.remove("dragging-over-top"),classList.add("dragging-over","dragging-over-bottom"))}}function onItemDragLeave(e){var listType,data=window.CurrentDragInfo,item=data?data.item:null;item&&(this.classList.contains("full-drop-target")?("Playlist"===(listType=this.getAttribute("data-type"))&&itemHelper.supportsAddingToPlaylist(item)||"BoxSet"===listType&&itemHelper.supportsAddingToCollection(item))&&(e.preventDefault(),this.dragCounter--,(this.dragCounter<=0||browser.firefox)&&(this.classList.remove("dragging-over"),this.dragCounter=0)):this.classList.contains("ordered-drop-target")&&(e.preventDefault(),this.classList.remove("dragging-over","dragging-over-top","dragging-over-bottom")))}function onItemDrop(e){e.preventDefault();var draggedElement=window.CurrentDragInfo.element,item=window.CurrentDragInfo.item;this.classList.remove("dragging-over","dragging-over-top","dragging-over-bottom"),this.classList.contains("full-drop-target")?onDroppedOntoFullTarget(this.closest(".itemsContainer"),0,this,item):this.classList.contains("ordered-drop-target")&&onDroppedForReordering(e,this.closest(".itemsContainer"),draggedElement,this),this.dragCounter=0}function addDragEventsToDropTarget(elem){elem.addEventListener("dragstart",onItemDragStart),elem.addEventListener("dragend",onItemDragEnd),elem.addEventListener("dragenter",onItemDragEnter),elem.addEventListener("dragover",onItemDragOver),elem.addEventListener("dragleave",onItemDragLeave),elem.addEventListener("drop",onItemDrop)}var EmbyItemsContainer=function(_HTMLDivElement){babelHelpers.inherits(EmbyItemsContainer,_HTMLDivElement);var _super=_createSuper(EmbyItemsContainer);function EmbyItemsContainer(){var _this;babelHelpers.classCallCheck(this,EmbyItemsContainer);var self=_this=_super.call(this);return onInit.call(self),babelHelpers.possibleConstructorReturn(_this,self)}return babelHelpers.createClass(EmbyItemsContainer,[{key:"connectedCallback",value:function(){var element;onInit.call(this),this.addEventListener("click",onClick),"false"!==this.getAttribute("data-contextmenu")&&((element=this).addEventListener("contextmenu",onContextMenu,!0),(browser.iOS||browser.osx)&&(dom.addEventListener(element,"touchstart",onTouchStart,{passive:!0}),dom.addEventListener(element,"touchend",onTouchEnd,{}),dom.addEventListener(element,"touchcancel",onTouchEnd,{}))),layoutManager.tv?this.classList.add("itemsContainer-tv"):"false"!==this.getAttribute("data-multiselect")&&this.enableMultiSelect(!0),itemShortcuts.on(this,{click:!1}),addNotificationEvent(this,"UserDataChanged",onUserDataChanged),addNotificationEvent(this,"TimerCreated",onTimerCreated),addNotificationEvent(this,"SeriesTimerCreated",onSeriesTimerCreated),addNotificationEvent(this,"TimerCancelled",onTimerCancelled),addNotificationEvent(this,"SeriesTimerCancelled",onSeriesTimerCancelled),addNotificationEvent(this,"LibraryChanged",onLibraryChanged),addNotificationEvent(this,"playbackstop",onPlaybackStopped,playbackManager),!layoutManager.tv&&"ontouchstart"in document&&require(["dragDropTouch"]),this.dispatchEvent(new CustomEvent("upgraded",{cancelable:!1}))}},{key:"disconnectedCallback",value:function(){clearRefreshInterval(this),abortRequests(this),this.enableMultiSelect(!1),this.removeEventListener("click",onClick),this.removeEventListener("contextmenu",onContextMenu),itemShortcuts.off(this,{click:!1}),removeNotificationEvent(this,"UserDataChanged"),removeNotificationEvent(this,"TimerCreated"),removeNotificationEvent(this,"SeriesTimerCreated"),removeNotificationEvent(this,"TimerCancelled"),removeNotificationEvent(this,"SeriesTimerCancelled"),removeNotificationEvent(this,"LibraryChanged"),removeNotificationEvent(this,"playbackstop",playbackManager),this.fetchData=null,this.getItemsHtml=null,this.parentContainer=null,this.virtualScroller=null,this.currentListOptions=null,this.itemParts=null,this.items=null}},{key:"pause",value:function(){clearRefreshInterval(this,!0),this.paused=!0;var virtualScroller=this.virtualScroller;virtualScroller&&virtualScroller.pause()}},{key:"resume",value:function(options){this.paused=!1;var remainingMs,refreshIntervalEndTime=this.refreshIntervalEndTime;refreshIntervalEndTime&&(0<(remainingMs=refreshIntervalEndTime-Date.now())&&!this.needsRefresh?resetRefreshInterval(this,remainingMs):(this.needsRefresh=!0,this.refreshIntervalEndTime=null));var virtualScroller=this.virtualScroller;return virtualScroller&&virtualScroller.resume(),this.needsRefresh||options&&options.refresh?this.refreshItems():Promise.resolve()}},{key:"getItem",value:function(index){var scroller=this.virtualScroller;if(scroller)return scroller.getItem(index);var items=this.items;return items?items[index]:null}},{key:"refreshItems",value:function(){if(!this.fetchData)return Promise.resolve();if(this.paused)return this.needsRefresh=!0,Promise.resolve();this.needsRefresh=!1,abortRequests(this);var abortController=new AbortController;this.currentAbortController=abortController;var query={},limit=getVirtualChunkSize(this);return limit&&(query.Limit=limit),this.fetchData(query,abortController.signal).then(onDataFetched.bind(this),onGetItemsFailed)}},{key:"notifyRefreshNeeded",value:function(isInForeground){var timeout;this.paused?this.needsRefresh=!0:((timeout=this.refreshTimeout)&&clearTimeout(timeout),!0===isInForeground?this.refreshItems():this.refreshTimeout=setTimeout(this.refreshItems.bind(this),1e4))}},{key:"showMultiSelect",value:function(childElement,selected){var card=itemShortcuts.getItemElementFromChildNode(childElement,!0);this.multiSelect.showSelections(card,selected)}},{key:"enableMultiSelect",value:function(enabled){var self,current=this.multiSelect;enabled?current||(self=this,require(["multiSelect"],function(multiSelect){MultiSelect=multiSelect,self.multiSelect=new MultiSelect({container:self})})):current&&(this.multiSelect=null)}},{key:"scrollToIndex",value:function(index,focus){var virtualScroller=this.virtualScroller;if(virtualScroller)return virtualScroller.scrollToIndex(index,focus);var item,focusableElement,items=this.querySelectorAll(".card,.listItem");!items.length||(item=items[index]||items[items.length-1])&&(focusableElement=item.querySelector(".cardContent-button")||item,focusManager.focus(focusableElement))}},{key:"pageUp",value:function(activeElement){var currentIndex,newIndex,virtualScroller=this.virtualScroller;(virtualScroller?virtualScroller._itemSource:this.items)&&(activeElement=itemShortcuts.getItemElementFromChildNode(activeElement,!0)||activeElement,newIndex=-1===(currentIndex=parseInt(activeElement.getAttribute("data-index")||"-1"))?0:Math.max(0,currentIndex-12),console.log("pageUp: "+newIndex),this.scrollToIndex(newIndex,!0))}},{key:"pageDown",value:function(activeElement){var currentIndex,newIndex,virtualScroller=this.virtualScroller,items=virtualScroller?virtualScroller._itemSource:this.items;items&&(activeElement=itemShortcuts.getItemElementFromChildNode(activeElement,!0)||activeElement,newIndex=-1===(currentIndex=parseInt(activeElement.getAttribute("data-index")||"-1"))?0:Math.min(items.length-1,currentIndex+12),console.log("pageDown: "+newIndex),this.scrollToIndex(newIndex,!0))}},{key:"focusLast",value:function(){var virtualScroller=this.virtualScroller,items=virtualScroller?virtualScroller._itemSource:this.items;items&&this.scrollToIndex(items.length-1,!0)}}]),EmbyItemsContainer}(babelHelpers.wrapNativeSuper(HTMLDivElement));return customElements.define("emby-itemscontainer",EmbyItemsContainer,{extends:"div"}),EmbyItemsContainer});